Subject: Re: [PATCH][next] net: ethernet: rmnet: Replace zero-length array with DECLARE_FLEX_ARRAY() helper

From: Jakub Kicinski <[email-masked]>
Date: Tue, 27 Sep 2022 07:07:02 -0700

On Mon, 26 Sep 2022 19:22:30 -0700 Kees Cook wrote:
> > Not directly related to this patch, but I just had to look at pahole
> > output for sk_buff and the struct_group() stuff makes is really painful
> > to read :/ Offsets for the members are relative to the "group" and they
> > are all repeated.
> > 
> > Is there any chance you could fix that? Before we sprinkle more pixie
> > dust around, perhaps?  
> 
> Unfortunately I don't see a way around it until we can make changes to
> the C language spec, and that's measured in decades. :(

I think BPF folks have had some success adding C extensions, like
tagging. Some form of attribute would really look so much better than
this DECLARE_FLEX_ARRAY() macro indirection. Maybe it's just me :(

> Perhaps we could add some kind of heuristic to pahole to "hide" one of
> the internal struct_group() copies, and to hide the empty flexible-array
> wrapper structs? (pahole already can't tell the difference between a
> 0-length array and a flexible-array.) Would that be workable?

That'd be my knee-jerk fix, too. Or at least render the offsets for 
the anonymous side of the union as absolute rather than relative.